controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Autor;
use app\models\Noticia;
use app\models\Seccion;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;



class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Mostrar las noticias de portada
     *
     * @return string
     */
    public function actionIndex()
    {
        // Necesito recuperar todas las noticias de la BBDD
        $consulta = Noticia::find();

        //$datos = $consulta->all(); // Las noticias estan en un array de modelos
        //$datos1 = $consulta->asArray()->all(); // Las noticias están en un array de arrays

        $datos = $consulta
            ->where(['portada' => 1]) // seleccionar
            ->all(); // ejecutar
        return $this->render('index', [
            'datos' => $datos,
            'titulo' => 'Noticias de portada'
        ]);
    }

    public function actionVernoticia($idNoticia)
    {
        $consulta = Noticia::find()->where(['idNoticia' => $idNoticia]);

        $dato = $consulta->one();

        return $this->render('verNoticia', [
            'dato' => $dato,
        ]);
    }

    public function actionSecciones()
    {
        $secciones = Seccion::find()->all();

        return $this->render('secciones', [
            'secciones' => $secciones
        ]);

        // return $this->render('secciones', compact('secciones));
    }

    public function actionSeccion($id)
    {
        $datos = Noticia::find()->where(['seccion' => $id])->all();

        // Hacemos la consulta para obtener el nombre de la seccion seleccionada
        $seccion = Seccion::find()->where(['id' => $id])->one();

        //$seccion = Seccion::findOne($id); // Esto hace lo mismo pero solo vale cuando filtras por el primary key

        return $this->render("index", [
            "datos" => $datos,
            "titulo" => "Noticias de " . $seccion->nombre,
        ]);
    }

    public function actionAutores()
    {
        $autores = Autor::find()->all();

        return $this->render('autores', [
            'autores' => $autores
        ]);
        // return $this->render('autores', compact('autores));
    }

    public function actionAutor($id)
    {
        $datos = Noticia::find()->where(['autor' => $id])->all();

        // Hacemos la consulta para obtener el nombre de la seccion seleccionada
        $autor = Autor::find()->where(['id' => $id])->one();


        return $this->render("index", [
            "datos" => $datos,
            "titulo" => "Noticias de " . $autor->nombre
        ]);
    }
}

views/site/_noticia.php
<?php

use yii\helpers\Html;

?>
<div class="noticia">

    <h3><?= $dato['titular'] ?></h3>


    <p><?= $dato['textoCorto'] ?></p>

    <?= Html::img("@web/imgs/noticias/{$dato['foto']}", ['width' => '150px', 'class' => 'img-thumbnail']) ?>
    <br>
    <?= Html::a('Ver noticia', ['site/vernoticia', 'idNoticia' => $dato->idNoticia], ['class' => 'botonPortada']) ?>

</div>

views/site/autores.php
<?php

use yii\helpers\Html;

?>

<div class="jumbotron text-center bg-transparent mt-5 mb-5 tituloPortada">
    <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>
    <h1 class="display-4">Autores</h1>
    <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>
</div>

<div class="row">
    <?php
    foreach ($autores as $autor) {
    ?>
        <div class="col-4 mb-3">
            <div class="card bg-warning text-dark cartas">
                <div class="imagenCard">
                    <?php
                    if (isset($autor->foto)) {
                        echo Html::img("@web/imgs/autores/{$autor->foto}", ["width" => 100, "height" => 100, 'style' => 'border-radius:50%;margin:5px']);
                    } else {
                        echo Html::img("@web/imgs/autores/anonimo.png", ["width" => 100, "height" => 100, 'style' => 'border-radius:50%;margin:5px']);
                    }
                    ?>
                </div>
                <div class="card-body">
                    <h5 class="card-title"><?= $autor->nombre ?></h5>
                    <?= Html::a('Ver noticias', ['site/autor', 'id' => $autor->id], ['class' => 'btn btn-light']) ?>

                </div>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5 tituloPortada">
        <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>
        <h1 class="display-4"><?= isset($titulo) ? $titulo : "Noticias" ?></h1>
        <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>

    </div>


    <div class="conjuntoNoticias">
        <?php
        foreach ($datos as $dato) {
            echo $this->render('_noticia', [
                'dato' => $dato,
            ]);
        }
        ?>

    </div>
</div>

views/site/secciones.php
<?php

use yii\helpers\Html;

?>

<div class="jumbotron text-center bg-transparent mt-5 mb-5 tituloPortada">
    <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>
    <h1 class="display-4">Secciones</h1>
    <?= Html::img('@web/imgs/NoticiasPortada.jpg', ['class' => 'img-thumbnail', 'width' => '225px']);   ?>
</div>

<div class="row">
    <?php
    foreach ($secciones as $seccion) {
    ?>
        <div class="col-4 mb-3">
            <div class="card bg-primary text-white cartas">
                <div class="imagenCard">
                    <?php
                    if (isset($seccion->foto)) {
                        echo Html::img("@web/imgs/secciones/{$seccion->foto}", ["width" => 100, "height" => 100, 'style' => 'border-radius:50%;margin:5px']);
                    } else {
                        echo Html::img("@web/imgs/secciones/notfound.png", ["width" => 100, "height" => 100, 'style' => 'border-radius:50%;margin:5px']);
                    }
                    ?>
                </div>
                <div class="card-body">
                    <h5 class="card-title"><?= $seccion->nombre ?></h5>
                    <?= Html::a('Ver noticias', ['site/seccion', 'id' => $seccion->id], ['class' => 'btn btn-light']) ?>

                </div>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/verNoticia.php
<?php

use yii\helpers\Html;
?>
<table class="tablaNoticia">
    <tr>
        <td>Titular</td>
        <td><?= $dato->titular ?></td>
    </tr>
    <tr>
        <td>Texto largo</td>
        <td><?= $dato->textoLargo ?></td>
    </tr>
    <tr>
        <td>Foto</td>
        <td><?= Html::img("@web/imgs/noticias/{$dato->foto}") ?></td>
    </tr>
    <tr>
        <td>Autor</td>
        <td> <?= $dato->autor ?></td>
    </tr>
    <tr>
        <td>Fecha</td>
        <td> <?= $dato->fecha ?></td>
    </tr>
    <tr>
        <td>Sección</td>
        <td> <?= $dato->seccion ?></td>
    </tr>

</table>